<?php
//-------------------------------------------------------------------------
// OVIDENTIA http://www.ovidentia.org
// Ovidentia is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
// USA.
//-------------------------------------------------------------------------
/**
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License (GPL)
 * @copyright Copyright (c) 2006 by CANTICO ({@link http://www.cantico.fr})
 */
//include_once 'base.php';

require_once $GLOBALS['babInstallPath'] . '/addons/widgets/widgets/inputwidget.class.php';





/**
 * A Widget_DelayedItem
 *
 *
 */
class Widget_DelayedItem extends Widget_InputWidget implements Widget_Displayable_Interface
{

	protected $delayedAction = null;


	/**
	 * @param Widget_Action $delayedAction An action returning a widget.
	 * @param string        $id            The item unique id.
	 * @return Widget_InputWidget
	 */
	public function __construct(Widget_Action $delayedAction = null, $id = null)
	{
		parent::__construct($id);
		$this->setDelayedAction($delayedAction);
	}


	/**
	 * @param Widget_Action $delayedAction
	 *
	 * @return Widget_DelayedItem
	 */
	public function setDelayedAction(Widget_Action $delayedAction = null)
	{
		$this->delayedAction = $delayedAction;
		return $this;
	}


	/**
	 * Returns
	 *
	 * @return Widget_Action
	 */
	public function getDelayedAction()
	{
		return $this->delayedAction;
	}


	/**
	 * (non-PHPdoc)
	 * @see programs/widgets/Widget_InputWidget#getClasses()
	 *
	 * @return array
	 */
	public function getClasses()
	{
		$classes = parent::getClasses();
		$classes[] = 'widget-delayeditem';
		return $classes;
	}


	public function display(Widget_Canvas $canvas)
	{
		if ($this->getDelayedAction()) {
			$this->setMetadata('delayedAction', $this->getDelayedAction()->url());
		}
		return $canvas->div(
			$this->getId(),
			$this->getClasses(),
			array()
		)
		. $canvas->metadata($this->getId(), $this->getMetadata());
	}

}
